' CamsDesign.bas for FilmStar DESIGN 32 bit
' Copyright 1995-1999 FTG Software Associates
' Modified 12.17.99
'
' Imports CAMS files into FilmStar
' Set up required Film Indices conversions in Sub Main before using

DefInt i-N
DefSng A-H, O-Z
Option Explicit
Option Base 1
Dim Conv$()
Dim dName$, fName$, file$, desc$

Sub Main
    Dim k
    ' *****************************************************
    ' Define film conversions - add more lines as required
    
    ReDim Conv$(2) ' increase when adding conversions
    
    Conv$(1) = "TIO2 H"
    Conv$(2) = "SIO2 L"
    
    ' *****************************************************
    dName$ = IniString("Cams", "DataPath")   
    OpenFile
    WriteIniString "Cams", "DataPath", dName$
    k = Macro("ArchiveMode 1;Busy 0;")
    Clipboard desc$  ' copy description to keyboard
    MainActivate
    ' Save as FILM Archive file
    SendKeys "{F12}{TAB}+{INS}+{TAB}" & fName$  ' store design
End Sub

Sub OpenFile
   Dim i
   file$ = GetFilePath$(,,dName$, "Open CAMS Design", 0)
   If file$ = "" Then
      End
   Else
      For i = Len(file$) To 1 Step -1
         If Mid$(file$, i, 1) = "\" Then
            dName$ = Left$(file$, i - 1)            ' directory
            fName$ = Right$(file$, Len(file$) - i)  ' OK as is for Mac
          ' Uncomment next line to remove PC file extension
          ' fName$ = Left$(fName$, Len(fName$) - 4)
            Exit For
        End If
      Next i
      Cams_to_Design
   End If
End Sub

Sub Cams_to_Design
    Dim i, k, des$, dum$, lin$
    If fName$ = "" Then Exit Sub
    Open file$ For Input As #1
    Line Input #1, dum$         ' skip first line
    Line Input #1, lin$         ' description
    lin$ = Mid$(lin$, 5)
    If Len(lin$) > 50 Then lin$ = Left$(lin$, 50)
    desc$ = lin$            ' keep description
    Line Input #1, dum$     ' skip substrate index    
    Do
       Line Input #1, lin$     
       lin$ = Trim$(lin$)
       For i = 1 To UBound(Conv$)
          If Left$(lin$, 4) = Left$(Conv$(i), 4) Then             
             ' Assumes CAMS Layer 1 is next to air
             des$ = Trim$(Mid$(lin$, 6)) & Right$(Conv$(i), 1) & " " & des$              
             ' If this is not the case then use
             'des$ = des$ & Trim$(Mid$(lin$, 6)) & Right$(Conv$(i), 1) & " "               
             Exit For
          End If
       Next i
       Design = Trim$(des$)     ' transfers design
       Select Case Left$(lin$, 4)
       Case "ANGL"
          Angle = Val(Trim$(Mid$(lin$, 6)))
       Case "LAMB"
          k = Macro("DesignWave " & CStr(1000 * Val(Trim$(Mid$(lin$, 6)))) & ";")      
       End Select      
   Loop Until Left$(lin$, 3) = "EOS"
   Close #1
End Sub

