' MonitorWidthLow.bas for FilmStar DESIGN
' Copyright 2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Adds monochromator bandwidth to R/T vs thickness (monitor) calculations
' Low resolution (adequate for many cases) 5 points
'
' To run this program As a Macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Monitor Bandwidth
'   Command       basrun c:\winfilm\basic32\MonitorWidthLow.bas;

Public wh!
Option Explicit

Sub Main
    On Error Resume Next    ' in case Cancel pushed
    wh = Val(IniString("Monochromator", "Bandwidth"))
    If wh = 0 Then wh = 5
    wh = Val(InputBox("50% bandwidth in nm?", "Monochromator Simulation", CStr(wh)))
    If wh > 0 Then
        LowRes   ' low + high + monochromatic
        WriteIniString "Monochromator", "Bandwidth", CStr(wh)
    End If
End Sub

Sub LowRes	' 5 points
    Dim i, w!, z!, s$
    PlotClose
    PlotLegendOn False
    PlotTitle = "Bandwidth = " & CStr(wh) & " nm"
    PlotActivate
    w! = EvalWave
    For z = w - wh To w + wh Step wh/2
        EvalWave = z
        Calculate
        PlotNext
    Next z
    s$ = "B=(.0625*B + .5*C + D + .5*E + .0625*F)/2.125;"
    For i = 70 To 67 Step -1
        s$ = s$ & "del " & Chr$(i) & ";"
    Next i
    PlotRun s$
    EvalWave = w
End Sub
