' MPLOT32.BAS for FilmStar DESIGN
' Copyright 1995-1999 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program shows how multiple graphs with multiple plots
' can be used in the FilmStar DESIGN Report Generator.
' You can use a RAM disk for speed.
' If you don't use a RAM disk, use BASIC's Kill instruction
' to delete .wmf files when the program is done.

Const DataDrive$ = "c:\"  ' change to RAM drive for greater speed
Const CRLF = Chr$(13) & Chr$(10)

Sub Main
    PlotClose     ' erase any current graphs
    PlotActivate  ' activate FSPlot window
    PlotSize 8500, 7500, 75  ' fix window size
    PlotLegendOn 1       ' in case it was off
    Angle=0
    k=Macro("Calculate;")
    PlotLegend(1)= "Angle 0"
    PlotNext
    Angle=10
    k=Macro("Calculate;")
    PlotLegend(2)= "Angle 10"
    PlotNext
    PlotSave DataDrive$ & "test1"  ' Save first plot
    PlotClose
    DoEvents
    PlotActivate
    Angle=20: k=macro("Calculate;")
    PlotLegend(1) = "Angle 20"
    PlotNext
    Angle=30: k=macro("Calculate;")
    PlotLegend(2) = "Angle 30"
    PlotNext
    PlotSave DataDrive$ & "test2"  ' Save second plot
    t$ = CRLF & "<<Picture " & DataDrive$ & "test1.wmf>>" & CRLF & CRLF
    t$ = t$ & "<<Picture " & DataDrive$ & "test2.wmf>>"
    Template=t$   ' Create report template
    k=Macro("ShowReport;")  ' Show the report
End Sub
