' RAND.BAS for FilmStar DESIGN
' Copyright 1995-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program illustrates how to do tolerancing. Since tolerancing can also be
' performed without BASIC, this would be used for special requirements. For example
' it could be used when errors are not completely random.
'
'     DESIGN BASIC functions used here (press F2 for help)
'
' GetLayers.......Convert current design to layers mode and place in array
'     GetLayers nq, q!(), qt$(), qdesc$()
'
' Macro...........Call DESIGN macro function (see DDE help)
'     kOK = Macro("AxesDraw;PlotStart;")
'
' SetLayers.......Set DESIGN layers equal to new array
'     SetLayers q!(), qt$()  note: must be dimensioned 1 To # Layers
'
' BasActivate.....Activate BASIC window
'
' RndNorm.........Get psuedo-normal random number
'
Option Explicit
DefInt i-n
DefSng A-H, O-Z
Dim q(), q0(), qType$(), qDesc$()

Sub Main
    Dim i, n, nLay
    MainActivate
    GetLayers nLay, q0(), qType(), qDesc()
    ReDim q(nLay)
    AxesDraw
    CalcPlotStart
    For n = 1 To 20   ' 20 iterations
        For i = 1 To nLay
            q(i) = q0(i) + .002 * RndNorm
        Next i
        SetLayers q(), qType()
        CalcPlot
        '
        '  ********* Code for interpreting spectra **********
        '
    Next n
    CalcPlotDone
    SetLayers q0(), qType() ' replace original design
    BasActivate
End Sub

