' TotalThickNM.bas for FilmStar DESIGN
' Copyright 1995-2021 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a list of total physical thicknesses
'
Option Explicit
DefInt i-n
DefSng a-h, o-z
Option Base 1

Sub Main
    Dim i, j, nl, q(), qt$(), qd$(), d$
    Dim mat$, mats$

    DesignConvert 1, "N"            ' convert to nanometers
    GetLayers nl, q(), qt(), qd()   ' get design

    For i = 1 To nl
        If InStr(mats$, qt(i)) = 0 Then mats$ = mats$ & qt(i)
    Next i

    ReDim tot(Len(mats$))
    For j = 1 To Len(mats$)
        mat$ = Mid$(mats$, j, 1)
        For i=1 To nl
            If qt(i) = mat$ Then tot(j) = tot(j) + q(i)
        Next i
        d$ = d$ & mat$ & ": " & Format$(tot(j),"0.00") & " nm" & vbCrLf
    Next j

    Display d$, "Total Thicknesss", 6000, 3500, "Arial", 16, 1
End Sub

