' LogOn.bas for FilmStar DESIGN 32 bit
' Copyright 2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program shows how to log on to different directories
' It is very useful for keeping customer projects separate
' Suggestion: specify as Start Up macro

' Program assumes that your directories are organized as below:

'         Winfilm
'            Data
'            Designs
'            Index
'            Spectra
'            OIC2001
'                GFF
'                    Data
'                    Designs
'                    Index
'                    Spectra
'            FTGSupport
'                Data
'                Designs
'                Index
'                Spectra
'            etc.

Option Explicit

' Change as required
Const bPath$ = "c:\Winfilm\"  ' Include trailing "\"!!

Sub Main
    On Error GoTo Quit
    Dim DirDesc(3) As String, DirName(3) As String, kDir As Integer

    DirDesc(0) = "Default"  ' Descriptions
    DirDesc(1) = "OIC2001 GFF Problem"
    DirDesc(2) = "FTG Support"

    DirName(0) = ""                ' Subdirectories
    DirName(1) = "OIC2001\GFF\"    ' Include trailing "\"!!
    DirName(2) = "FTGSupport\"

    kDir = Val(IniString("Files", "DirNum"))    ' Get previous selection
    Begin Dialog UserDialog 360,140,"Log On to Directory" ' %GRID:10,7,1,1
        ListBox 40,21,190,105,DirDesc(),.lstDir
        OKButton 260,28,80,23
        CancelButton 260,63,80,23
    End Dialog
    Dim dlg As UserDialog
    dlg.lstDir = kDir
    Dialog dlg
    kDir = dlg.lstDir
    DefaultPath bPath & DirName(kDir) & "Data", bPath & DirName(kDir) & "Designs", bPath & DirName(kDir) & "Index", bPath & DirName(kDir) & "Spectra"
  ' Since DefaultPath parameters are optional, you could keep the same Index directory as below:
  ' DefaultPath bPath & DirName(kDir) & "Data", bPath & DirName(kDir) & "Designs",, bPath & DirName(kDir) & "Spectra"
    WriteIniString("Files", "DirNum", CStr(kDir))   ' Store selection
Quit:
    Exit Sub
End Sub
