'#Reference {00020813-0000-0000-C000-000000000046}#1.3#0#C:\Program Files\Microsoft Office\Office\EXCEL9.OLB#Microsoft Excel 9.0 Object Library
' MultCalcXLC.bas for FilmStar DESIGN
' Copyright 2011 FTG Software Associates

' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************

' Insert spectra into Excel Workbook MultCalc0.xls
' Uses MS Excel via COM; similar to MultCalcXL.bas
' which does not require Excel

Option Explicit
Option Base 1
DefInt i-n
DefSng A-H, O-Z
Dim xlApp As Excel.Application
Dim xlBook As Excel.Workbook
Dim xlSheet As Excel.Worksheet
Dim nDat, iCol

Const path$ = "C:\Winfilm\Workbook\"
Const kType = 2   ' 1 Reflectance, 2 Transmittance

Sub Main
	Dim i, ang, xDat()
	If Not OpenXlsFile(path$ & "MultCalc0.xls") Then End
	Calculate
	xDat = Spectrum_X
	nDat = UBound(xDat)
	For i = 1 To nDat
		xlSheet.Cells(i + 2, 1) = xDat(i)
	Next i
	For ang = 0 To 60 Step 15	' adjust as required
		DoCalc ang, "P"
		DoCalc ang, "S"
	Next ang
    xlSheet.SaveAs path$ & "MultCalc1.xls"
End Sub

Sub DoCalc(ang, p$)
	Dim i, yDat()
	Angle = ang: Pol = p$: iCol = iCol + 1
	If iCol < 257 Then	' FS Workbook limit
	    xlSheet.Cells(1, iCol + 1) = CStr(ang)
		xlSheet.Cells(2, iCol + 1) = p$
		Calculate
		yDat = Spectrum_Y
		For i = 1 To nDat
			xlSheet.Cells(i + 2, iCol + 1) =  yDat(i, kType)
		Next i
	End If
End Sub

Function OpenXlsFile(ByVal f$) As Boolean
	' If you get an error in the next line, you need to re-establish
	' a reference to the Microsoft Excel Object Library
	Set xlApp = New Excel.Application
	On Error GoTo OpenXLSErr
    Set xlBook = xlApp.Workbooks.Open(f$)
    Set xlSheet = xlBook.Sheets(1)
    xlApp.Calculation = xlCalculationManual ' faster
    xlApp.DisplayAlerts = False	' no save prompt upon exiting Excel
    xlApp.Visible = True
	OpenXlsFile = True
	Exit Function
OpenXLSErr:
    OpenXlsFile = False
End Function

