'#Reference {00020905-0000-0000-C000-000000000046}#8.0#409#C:\Program Files\Microsoft Office\Office\MSWORD8.OLB#Microsoft Word 8.0 Object Library
' Review_Word97.bas for FilmStar DESIGN 32 bit
' Copyright 1998-2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates Review Design documents in Word 97

'*********************************************************
'                   DOESN'T WORK? 
'       1. Verify that Microsoft Word Object Library
'          is checked in Edit...References. This example
'          was developed for 8.0 and may need to be
'          updated
'
'       2. Check that ReviewDesign.doc is in
'          ..\Winfilm\Word 97 
'*********************************************************

Option Explicit
DefInt I-N
Const TmpDir$ = "c:\windows\temp\"
Const dname$ = "Fred Goldstein"
Dim dword As Word.Application

Sub Main
    Dim k, kf, f$
    Set dword = New Word.Application    
    PlotClose ' just in case it's open
    GraphSetup
    On Error Resume Next
    Do
        If kf = 0 Then
            f$ = Dir$(PgmPath & "\Designs\*.faw")
            kf = 1
        Else
            f$ = Dir$()
        End If
        If f$= "" Then Exit Do
        k = Macro("ArchiveOpen " & PgmPath & "\Designs\" & f$ & ";Calculate;")
        Kill TmpDir & "temp.wmf"    ' can be either .wmf or .bmp
        Kill TmpDir & "temp.bmp"    ' so erase both
        PlotActivate
        PlotNext
        Select Case MsgBox("Save document '" & DocName(f$) &"'?", 35, "FILM Archive to Word 97")
        Case vbYes
            PlotSave TmpDir & "temp"
            Wait 1      ' seems necessary to get right graph in document
            PlotClose   ' may have to increase time on slow computers
            SaveDoc f$ 
        Case vbNo
            PlotClose
        Case vbCancel
            PlotClose
            Exit Do
        End Select
    Loop
    dword.Quit False
    Set dword = Nothing
End Sub

Sub SaveDoc(f$)
    Dim k
    On Error Resume Next
    dword.Documents.Open FileName:= PgmPath & "\Word 97\ReviewDesign.doc"
    With dword.ActiveDocument
        k = FileLen (TmpDir & "temp.wmf")
        If k > 0 Then ' Use Bookmarks to place picture
            .InlineShapes.AddPicture TmpDir & "temp.wmf", False, True, .Bookmarks("Graph").Range            
        Else
            k = FileLen (TmpDir & "temp.bmp")
            If k > 0 Then .InlineShapes.AddPicture TmpDir & "temp.bmp", False, True, .Bookmarks("Graph").Range          
        End If          
        If k > 0 Then
            .Variables("Name").Value = dname$
            .Variables("Review").Value = Replace(Review(1), vbCrLf, vbCr)
            .InlineShapes(1).LockAspectRatio = 0    ' msoFalse
            .InlineShapes(1).Height = dword.InchesToPoints(3.5)
            .InlineShapes(1).Width = dword.InchesToPoints(5.5)
            .Fields.Update
            .SaveAs PgmPath & "\Word 97\" & DocName(f$)
            .Close -1   ' wdSaveChanges
        End If
    End With
End Sub

Function DocName$(f$)
    DocName = LCase$(Left$(f$, Len(f$) - 4)) & ".doc"
End Function

Sub GraphSetup
' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 8469714, 130, 0
    PlotSize 9500, 8250, 90
    PlotTitleFont = "Arial"
    PlotTitleSize = 120
    PlotLegendSize = 100
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 100
    PlotAxesNumberSize = 100
    PlotFontFixed = False
    PlotFontFixedSize = 1
    PlotAxesConfig = 0
    PlotEdgeSpace 50, -25, 50, 25
    PlotAxesSpace .15, .3, .3, 1.5
    'PlotColors "255, 16711680, 57088, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = False
End Sub

