' SEARCH.BAS for FilmStar DESIGN
' Copyright 1995-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This illustrates a 'global' search for a 2 layer design
' which minimizes a value in the FilmStar Workbook

DefInt I-N
DefSng A-H, O-Z

Sub Main
    Dim k As Boolean
    StatusLabel "Calculating - please wait"
    k = WbOpen("c:\winfilm\workbook\mtable.xls") ' Change as required
    If Not k Then End  ' In case the file is wrong
    vMin = 10000    ' big number
    For x1 = 0 To 200 Step 20        ' Layer 1 physical thickness
        For x2 = 0 To 500 Step 50    ' Layer 2 physical thickness
            MainActivate
            Design = CStr(x1) & "H" & " " & CStr(x2) & "L"
            Calculate
            DoEvents
            WbActivate
            v = WbGetNum("$E$5")     ' Change as required 
            If v < vMin Then 
                x1Min = x1
                x2Min = x2
                vMin = v
            End If
        Next x2
    Next x1
    MainActivate
    Design = CStr(x1Min) & "H" & " " & CStr(x2Min) & "L"
    AxesDraw
    CalcPlot
    Busy False
    StatusLabel "Done"
End Sub
