' SENSITIVITY_REL.BAS for FilmStar DESIGN
' Copyright 2002-2003 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program loops through layers and determines
' which one is most sensitive according to deviation
' from Merit function (defined in Opti Targets)
'
Option Explicit
DefInt i-N
DefSng A-H, O-Z
Dim nLay, q(), qt$(), qd$(), xMerit0

Sub Main
    Dim i, q0, xMer, xMer0, report$

'***************************************************************
    Const qErr = 2	        ' thickness percent error
'***************************************************************

    xMer0 = Merit		    ' get merit function of optimized design
    GetLayers nLay, q(), qt(), qd() ' get design information
    report$ = "Effect of " & Format$(qErr) & "% Thickness Error" & vbCrLf & vbCrLf
    For i=1 To nLay
        q0 = q(i)           ' store original layer thickness
        q(i) = q(i) * (1 + .01 * qErr)  ' change design
        SetLayers q(), qt()
        report$ = report$ & "Layer " & CStr(i) & ": Deviation " & Format$(100 * (Merit - xMer0)/xMer0, "0.00") & "%" & vbCrLf
        q(i) = q0           ' put back original design
        SetLayers q(), qt()
    Next i
    Busy False              ' in case hourglass remaining
    MsgBox report$, vbOkOnly, "Sensitivity Analysis" ' show results
End Sub
