' Spector1.bas for FilmStar DESIGN 32-bit
' Copyright 2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Exports Veeco Spector monitor file to disk

Option Base 1
Option Explicit
'
' *******************************************************************
'  ADJUST NEXT LINE for your computer (directory must already exist)
Const SpectorPath$ = "C:\Winfilm\Spector"
' *******************************************************************
'
DefInt i-N
DefSng A-H, O-Z

Sub Main
    Dim i, file$, nLayers, q1(), qt$(), qd$(), f$, s$
    If ArchiveMode Then f$ = FileName(8) Else f$ = FileName(7)
    file$ = GetFilePath$(f$, "fsd", SpectorPath$, "Save Spector Monitor File", 3)
    If file$ = "" Then End
    Open file$ For Output As #1
    Print #1, "ITISPECTORDESIGN"
    Print #1, "VERSION:1"
    Print #1, "DESIGNWAVELENGTH:" & Format$(DesignWave)
    ' Convert to optical thickness if necessary
    DesignConvert 2, 1
    ' Get the design
    GetLayers nLayers, q1(), qt$(), qd$()
    Print #1, "LAYERS:" & Format$(nLayers)
    For i = 1 To nLayers
        s$ = "LAYER:" & Format$(i) & ":" & qt$(i) & ":"
        If DesignQwotUnit = 1 Then  ' QWOT = .25 convention
            Print #1, s$ & Format$(4*q1(i), "0.000000")
        Else    ' QWOT = 1 convention
            Print #1, s$ & Format$(q1(i), "0.000000")
        End If
    Next i
    Close #1
End Sub
