' ThickList.bas for FilmStar DESIGN, MEASURE 32-bit
' Copyright 1995-2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a list of physical thicknesses for crystal controllers
' The design remains in optical thickness
' It gets the material name from the Description column in Film Indices
'
Option Explicit
DefInt i-n
DefSng a-h, o-z
Option Base 1

Sub Main
    Dim dname$, file$, iTank, ok As Boolean
    Dim ToolH, ToolL, ToolM
    Dim i, nl, q(), qt$(), qd$(), d$
    DesignConvert 1, "N"            ' convert to k
    GetLayers nl, q(), qt(), qd()   ' get design
    For i = 1 To nl
        d$ = d$ & Format$(i, "000") & "    " & Format$(q(i), "0.00") & " nm     " _
             & Format$(.01 * q(i), "0.000") & " k  " & qd(i) & vbCrLf & String$(60, "-") & vbCrLf
    Next i
    Display d$, "Crystal monitor settings", 6000, 4500, "Arial", 10, 1
    DesignConvert 2		' convert to optical according to settings
End Sub

