' WaveAtMax.bas for FilmStar MEASURE
' Copyright 2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************

' What wavelength corresponds to maximum reflectance value?

Option Explicit
Option Base 1

Sub Main
    Dim i%, iMax%, xData!(), yData!(), yMax!
    Const xMin = 450, xMax = 750   ' specifying range is optional
    xData = Spectrum_X
    yData = Spectrum_Y
    yMax = -1
    For i = 1 To UBound(xData)
        If xData(i) >= xMin And xData(i) <= xMax Then  ' use if range specified
            If yData(i) > yMax Then
                iMax = i
                yMax = yData(i)
            End If
        End If
    Next i
    MsgBox "Wavelength at yMax = " & Format$(100*yData(iMax), "0.00") & "% is " & CStr(xData(iMax))
End Sub
